-- ================================================================== --
-- SISTEMA         : PEDIDO                                           --
-- DATA DA CRIAO : INCIO - 12/08/2002                              --
-- CRIAO         : Andr Rodrigo                                    --
-- OBJETIVO        : Gera comisso do vendedor por item do pedido     --
-- ================================================================== --

IF EXISTS (SELECT *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'GRAVA_VENDITEMPED' AND
	              TYPE = 'P' 			          AND
      	        U.UID = O.UID                AND
      	        U.NAME = USER)
DROP PROCEDURE GRAVA_VENDITEMPED
GO
CREATE PROCEDURE GRAVA_VENDITEMPED @P_CDFILIAL     VARCHAR(04),
                                   @P_NRPEDIDO     VARCHAR(10),
                                   @P_CDVENDEDOR   VARCHAR(04),
                                   @P_VRPECOMITPED DOUBLE PRECISION,
                                   @P_CDOPERADOR   VARCHAR(12)= NULL,
                                   @P_NRITEMALTER  VARCHAR(10)= NULL
AS
  DECLARE @V_NRITEMPED    VARCHAR(10);
  DECLARE @V_IDSITITEMPED VARCHAR(01);
  DECLARE @V_CTPEVEND     INTEGER;
  DECLARE @V_VRCOMISANT   DOUBLE PRECISION;
BEGIN
   DECLARE C_ITEM CURSOR FOR
   SELECT NRITEMPED, IDSITITEMPED
   FROM ITEMPEDIDO
   WHERE
     (CDFILIAL = @P_CDFILIAL) AND
     (NRPEDIDO = @P_NRPEDIDO)

   OPEN C_ITEM;

   FETCH NEXT FROM C_ITEM INTO @V_NRITEMPED, @V_IDSITITEMPED;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF(@V_IDSITITEMPED = '1')OR(@V_IDSITITEMPED = '2')OR(@V_IDSITITEMPED = '3')BEGIN
         SELECT @V_CTPEVEND = COUNT(*)
         FROM VENDITEMPED
         WHERE
            (CDFILIAL   = @P_CDFILIAL)  AND
            (NRPEDIDO   = @P_NRPEDIDO)  AND
            (NRITEMPED  = @V_NRITEMPED) AND
            (CDVENDEDOR = @P_CDVENDEDOR);

         IF @V_CTPEVEND = 0 BEGIN
            INSERT INTO VENDITEMPED
               (CDFILIAL, NRPEDIDO, NRITEMPED,
                CDVENDEDOR, VRPECOMITPED)
            VALUES
               (@P_CDFILIAL, @P_NRPEDIDO, @V_NRITEMPED,
                @P_CDVENDEDOR, @P_VRPECOMITPED);

            IF (@P_NRITEMALTER IS NULL) OR (@P_NRITEMALTER <> @V_NRITEMPED) BEGIN
               INSERT INTO HISITEMPED
                   (CDFILIAL, IDSITATUHIST, NRITEMPED, IDSITANTHIST, IDALTHISTITE,
                    DTHRHIST, NRPEDIDO, CDOPEMANHIST,CDVENDORIG, VRCOMISSORIG,CDVENDATUAL,VRCOMISATUAL)
               VALUES
                   (@P_CDFILIAL, @V_IDSITITEMPED, @V_NRITEMPED, @V_IDSITITEMPED, '3',
                    GetDate(), @P_NRPEDIDO, @P_CDOPERADOR, NULL, NULL, @P_CDVENDEDOR, @P_VRPECOMITPED);
            END;
         END
         ELSE BEGIN
             SELECT V_VRCOMISANT = VRPECOMITPED
             FROM VENDITEMPED
             WHERE
                (CDFILIAL   = @P_CDFILIAL) AND
                (NRPEDIDO   = @P_NRPEDIDO) AND
                (NRITEMPED  = @V_NRITEMPED) AND
                (CDVENDEDOR = @P_CDVENDEDOR);

            UPDATE VENDITEMPED
            SET VRPECOMITPED = @P_VRPECOMITPED
            WHERE
               (CDFILIAL   = @P_CDFILIAL)  AND
               (NRPEDIDO   = @P_NRPEDIDO)  AND
               (NRITEMPED  = @V_NRITEMPED) AND
               (CDVENDEDOR = @P_CDVENDEDOR);

            IF (@P_NRITEMALTER IS NULL) OR (@P_NRITEMALTER <> @V_NRITEMPED) BEGIN
               INSERT INTO HISITEMPED
                  (CDFILIAL, IDSITATUHIST, NRITEMPED, IDSITANTHIST, IDALTHISTITE,
                   DTHRHIST, NRPEDIDO, CDOPEMANHIST,CDVENDORIG, VRCOMISSORIG,CDVENDATUAL,VRCOMISATUAL)
               VALUES
                   (@P_CDFILIAL, @V_IDSITITEMPED, @V_NRITEMPED, @V_IDSITITEMPED, '3',
                    GetDate(), @P_NRPEDIDO, @P_CDOPERADOR, @P_CDVENDEDOR, @V_VRCOMISANT, @P_CDVENDEDOR, @P_VRPECOMITPED);
            END;
         END;
      END;
      FETCH NEXT FROM C_ITEM INTO @V_NRITEMPED, @V_IDSITITEMPED;
   END;
   CLOSE C_ITEM;
   DEALLOCATE C_ITEM;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'GRAVA_VENDITEMPED','4.05.126';
GO

